.\" $NetBSD: puc.4,v 1.22 2008/04/03 20:45:08 riz Exp $
.\"
.\" Copyright (c) 1998 Christopher G. Demetriou
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"          This product includes software developed for the
.\"          NetBSD Project.  See http://www.NetBSD.org/ for
.\"          information about NetBSD.
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" <<Id: LICENSE,v 1.2 2000/06/14 15:57:33 cgd Exp>>
.\"
.Dd April 2, 2008
.Dt PUC 4
.Os
.Sh NAME
.Nm puc
.Nd PCI
.Dq universal
communications card driver
.Sh SYNOPSIS
.Cd "puc* at pci? dev ? function ?"
.Cd "com* at puc? port ?"
.Cd "lpt* at puc? port ?"
.Sh DESCRIPTION
The
.Nm
driver provides support for PCI communications cards containing
simple communications ports, such as NS16550-family
.Pf ( Nm com )
serial ports and standard PC-like
.Pf ( Nm lpt )
parallel ports.
The driver is called
.Dq universal
because the interfaces to these devices aren't nearly as well
defined and standard as they should be.
.Pp
The driver currently supports the following cards:
.Pp
.Bl -tag -width Dv -offset indent -compact
.It Tn "Dolphin Peripherals 4014 (dual parallel)"
.It Tn "Dolphin Peripherals 4035 (dual serial)"
.It Tn "NetMos NM9835 (dual parallel and single serial)"
.It Tn "SIIG Cyber 2P1S PCI (dual parallel and single serial)"
.It Tn "SIIG Cyber 2S1P PCI (dual serial and single parallel)"
.It Tn "SIIG Cyber 4S PCI (quad serial)"
.It Tn "SIIG Cyber I/O PCI (single serial and single parallel)"
.It Tn "SIIG Cyber Parallel Dual PCI (dual parallel)"
.It Tn "SIIG Cyber Parallel PCI (single parallel)"
.It Tn "SIIG Cyber Serial Dual PCI (dual serial)"
.It Tn "SIIG Cyber Serial PCI (single serial)"
.It Tn "VScom PCI-200 (dual serial)"
.It Tn "VScom PCI-400 (4-port serial"
.It Tn "VScom PCI-800 (8-port serial)"
.It Tn "Titan PCI-800 (8-port serial)"
.It Tn "Titan PCI-200 (dual serial)"
.It Tn "NEC PK-UG-X001 K56flex PCI Modem"
.It Tn "NEC PK-UG-X008"
.It Tn "Lava Computers 2SP-PCI (single parallel)"
.It Tn "Lava Computers dual serial"
.It Tn "Lava Computers Octopus (8-port serial)"
.It Tn "US Robotics (3Com) 3CP5609 PCI 16550 Modem"
.It Tn "Actiontec 56K PCI Master"
.It Tn "Oxford Semiconductor OX16PCI952 (dual serial and single parallel)"
.It Tn "Oxford Semiconductor OX16PCI954 (4-port serial)"
.It Tn "NetMos 1P PCI (single parallel)"
.It Tn "NetMos 2S1P PCI 16C650 (dual serial and single parallel)"
.It Tn "NetMos 4S1P PCI NM9845 (4-port serial and single parallel)"
.It Tn "Middle Digital, Inc. Weasel serial port"
.It Tn "Avlab Technology, Inc. Low Profile PCI 4 Serial (4-port serial)"
.It Tn "Boca Research Turbo Serial 654 (4-port serial)"
.It Tn "Chase Research / Perle PCI-FAST4 (4-port serial)"
.It Tn "Boca Research Turbo Serial 658 (8-port serial)"
.It Tn "Chase Research / Perle PCI-FAST8 (8-port serial)"
.It Tn "ADDI-DATA APCI-7800 (8-port serial)"
.It Tn "Moxa Technologies SmartIO CP104/PCI (4-port serial)"
.It Tn "EXAR XR17D152 (2-port serial)"
.It Tn "EXAR XR17D154 (4-port serial)"
.It Tn "EXAR XR17D158 (8-port serial)"
.It Tn "Digi International Digi Neo 4 (4-port serial)"
.It Tn "Digi International Digi Neo 8 (8-port serial)"
.El
.Pp
The driver does not support the cards:
.Pp
.Bl -tag -width Fl -offset indent -compact
.It Tn "Dolphin Peripherals 4006 (single parallel)"
.It Tn "Dolphin Peripherals 4025 (single serial)"
.It Tn "Dolphin Peripherals 4078 (dual serial and single parallel)"
.El
.Pp
but support for them (and for similar cards) should be trivial to add.
.Pp
The
.Ar port
locator is used to identify the port (starting from 0) on the
communications card that a subdevice is supposed to attach to.
Typically, the numbering of ports is explained in a card's
hardware documentation, and the port numbers used by the driver
are the same as (or one off from, e.g. the manual uses ports
numbered starting from 1) those described in the documentation.
.Sh SEE ALSO
.Xr com 4 ,
.Xr lpt 4 ,
.Xr pci 4
.Sh HISTORY
The
.Nm
driver appeared in
.Nx 1.4 .
.Sh AUTHORS
The
.Nm
driver was written by Chris Demetriou.
.Sh BUGS
The current design of this driver keeps any
.Nm com
ports on these cards from easily being used as console.
Of course, because boards with those are PCI boards, they also
suffer from dynamic address assignment, which also means that they
can't easily be used as console.
.Pp
Some of the cards supported by this driver have jumper-selectable
.Nm com
port clock multipliers, which are unsupported by this
driver.
Those can be easily accommodated with driver flags, or by
using a properly scaled baud rate when talking to the card.
.Pp
Some of the cards supported by this driver, e.g. the VScom PCI-800,
have software-selectable
.Nm com
port clock multipliers, which are unsupported by this driver.
Those can be accommodated using internal driver flags, or by using
a properly scaled baud rate when talking to the card.
.Pp
Some ports use an
.Nm lpt
driver other than the machine-independent driver.
Those ports will not be able to use
.Nm lpt
ports attached to
.Nm
devices.
